﻿Imports System.IO

Public Class Form1
    ' Get the basic file name.
    Private LogFileName As String
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LogFileName = Application.StartupPath
        LogFileName = Path.GetFullPath( _
            Path.Combine(LogFileName, "..\\..\\log.txt"))
    End Sub

    ' Write an entry into the log file.
    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        WriteToLog(txtEntry.Text, LogFileName, 100, 3)
        txtEntry.Clear()
        txtEntry.Focus()
    End Sub

    ' If the file exceeds max_size bytes, move it to a new file
    ' with .1 appended to the name and bump down older versions.
    ' (E.g. log.txt.1, log.txt.2, etc.)
    ' Then write the text into the main log file. 
    Private Sub WriteToLog(ByVal new_text As String, ByVal file_name As String, ByVal max_size As Long, ByVal num_backups As Integer)
        ' See if the file is too big.
        Dim file_info As New FileInfo(file_name)
        If (file_info.Exists AndAlso file_info.Length > max_size) Then
            ' Remove the oldest version if it exists.
            If (File.Exists(file_name & "." & num_backups.ToString())) Then
                File.Delete(file_name & "." & num_backups.ToString())
            End If

            ' Bump down earlier backups.
            For i As Integer = num_backups - 1 To 1 Step -1
                If (File.Exists(file_name & "." & i.ToString())) Then
                    ' Move file i to file i + 1.
                    File.Move(file_name & "." & i.ToString(), _
                         file_name & "." & (i + 1).ToString())
                End If
            Next i

            ' Move the main log file.
            File.Move(file_name, file_name & ".1")
        End If

        ' Write the text.
        File.AppendAllText(file_name, new_text & vbCrLf)
    End Sub
End Class
